diff --git a/libavcodec/Makefile b/libavcodec/Makefile
index 5b41450b86..c11645616d 100644
--- a/libavcodec/Makefile
+++ b/libavcodec/Makefile
@@ -978,9 +978,6 @@ OBJS-$(CONFIG_VP8_QSV_HWACCEL)            += qsvdec.o
 OBJS-$(CONFIG_ISO_MEDIA)               += mpeg4audio.o mpegaudiodata.o
 
 OBJS-$(CONFIG_ADTS_MUXER)              += mpeg4audio.o
-OBJS-$(CONFIG_CODEC2_DEMUXER)          += codec2utils.o
-OBJS-$(CONFIG_CODEC2_MUXER)            += codec2utils.o
-OBJS-$(CONFIG_CODEC2RAW_DEMUXER)       += codec2utils.o
 OBJS-$(CONFIG_DNXHD_DEMUXER)           += dnxhddata.o
 OBJS-$(CONFIG_FITS_DEMUXER)            += fits.o
 OBJS-$(CONFIG_LATM_MUXER)              += mpeg4audio.o
@@ -1023,8 +1020,8 @@ OBJS-$(CONFIG_LIBAOM_AV1_DECODER)         += libaomdec.o
 OBJS-$(CONFIG_LIBAOM_AV1_ENCODER)         += libaomenc.o
 OBJS-$(CONFIG_LIBARIBB24_DECODER)         += libaribb24.o ass.o
 OBJS-$(CONFIG_LIBCELT_DECODER)            += libcelt_dec.o
-OBJS-$(CONFIG_LIBCODEC2_DECODER)          += libcodec2.o codec2utils.o
-OBJS-$(CONFIG_LIBCODEC2_ENCODER)          += libcodec2.o codec2utils.o
+OBJS-$(CONFIG_LIBCODEC2_DECODER)          += libcodec2.o
+OBJS-$(CONFIG_LIBCODEC2_ENCODER)          += libcodec2.o
 OBJS-$(CONFIG_LIBDAV1D_DECODER)           += libdav1d.o
 OBJS-$(CONFIG_LIBDAVS2_DECODER)           += libdavs2.o
 OBJS-$(CONFIG_LIBFDK_AAC_DECODER)         += libfdk-aacdec.o
diff --git a/libavcodec/codec2utils.c b/libavcodec/codec2utils.c
deleted file mode 100644
index a942662403..0000000000
--- a/libavcodec/codec2utils.c
+++ /dev/null
@@ -1,82 +0,0 @@
-/*
- * codec2 utility functions
- * Copyright (c) 2017 Tomas Härdin
- *
- * This file is part of FFmpeg.
- *
- * FFmpeg is free software; you can redistribute it and/or
- * modify it under the terms of the GNU Lesser General Public
- * License as published by the Free Software Foundation; either
- * version 2.1 of the License, or (at your option) any later version.
- *
- * FFmpeg is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public
- * License along with FFmpeg; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
- */
-
-#include <string.h>
-#include "internal.h"
-#include "libavcodec/codec2utils.h"
-
-#if LIBAVCODEC_VERSION_MAJOR < 59
-int avpriv_codec2_mode_bit_rate(void *logctx, int mode)
-{
-    int frame_size  = avpriv_codec2_mode_frame_size(logctx, mode);
-    int block_align = avpriv_codec2_mode_block_align(logctx, mode);
-
-    if (frame_size <= 0 || block_align <= 0) {
-        return 0;
-    }
-
-    return 8 * 8000 * block_align / frame_size;
-}
-
-int avpriv_codec2_mode_frame_size(void *logctx, int mode)
-{
-    int frame_size_table[CODEC2_MODE_MAX+1] = {
-        160,    // 3200
-        160,    // 2400
-        320,    // 1600
-        320,    // 1400
-        320,    // 1300
-        320,    // 1200
-        320,    // 700
-        320,    // 700B
-        320,    // 700C
-    };
-
-    if (mode < 0 || mode > CODEC2_MODE_MAX) {
-        av_log(logctx, AV_LOG_ERROR, "unknown codec2 mode %i, can't find frame_size\n", mode);
-        return 0;
-    } else {
-        return frame_size_table[mode];
-    }
-}
-
-int avpriv_codec2_mode_block_align(void *logctx, int mode)
-{
-    int block_align_table[CODEC2_MODE_MAX+1] = {
-        8,      // 3200
-        6,      // 2400
-        8,      // 1600
-        7,      // 1400
-        7,      // 1300
-        6,      // 1200
-        4,      // 700
-        4,      // 700B
-        4,      // 700C
-    };
-
-    if (mode < 0 || mode > CODEC2_MODE_MAX) {
-        av_log(logctx, AV_LOG_ERROR, "unknown codec2 mode %i, can't find block_align\n", mode);
-        return 0;
-    } else {
-        return block_align_table[mode];
-    }
-}
-#endif
diff --git a/libavcodec/codec2utils.h b/libavcodec/codec2utils.h
index 37f0693dc7..6812ae895c 100644
--- a/libavcodec/codec2utils.h
+++ b/libavcodec/codec2utils.h
@@ -24,8 +24,6 @@
 
 #include <stdint.h>
 
-#include "version.h"
-
 //Highest mode we're willing to use.
 //Don't want to let users accidentally produce files that can't be decoded in the future.
 //CODEC2_MODE_WB (9) is experimental/unstable as of 2017-11-23.
@@ -47,22 +45,6 @@
     { "700B", "700B", 0, AV_OPT_TYPE_CONST, {.i64 = 7}, .flags=option_flags, .unit="codec2_mode"},\
     { "700C", "700C", 0, AV_OPT_TYPE_CONST, {.i64 = 8}, .flags=option_flags, .unit="codec2_mode"}
 
-#if LIBAVCODEC_VERSION_MAJOR < 59
-//The three following functions are here to avoid needing libavformat/codec2.c to depend on libcodec2
-
-//Computes bitrate from mode, with frames rounded up to the nearest octet.
-//So 700 bit/s (28 bits/frame) becomes 800 bits/s (32 bits/frame).
-//logctx is used for av_log()
-//Returns <0 if mode is invalid
-int avpriv_codec2_mode_bit_rate(void *logctx, int mode);
-
-//Mimics codec2_samples_per_frame()
-int avpriv_codec2_mode_frame_size(void *logctx, int mode);
-
-//Mimics (codec2_bits_per_frame()+7)/8
-int avpriv_codec2_mode_block_align(void *logctx, int mode);
-#endif
-
 #define CODEC2_EXTRADATA_SIZE 4
 
 //Used in codec2raw demuxer and libcodec2 encoder