diff --git a/libavcodec/Makefile b/libavcodec/Makefile
index 4a597f727a..5b41450b86 100644
--- a/libavcodec/Makefile
+++ b/libavcodec/Makefile
@@ -34,7 +34,6 @@ OBJS = ac3_parser.o                                                     \
        avpacket.o                                                       \
        avpicture.o                                                      \
        bitstream.o                                                      \
-       bitstream_filter.o                                               \
        bitstream_filters.o                                              \
        bsf.o                                                            \
        codec_desc.o                                                     \
diff --git a/libavcodec/avcodec.h b/libavcodec/avcodec.h
index 483ab9a358..5e6967df0d 100644
--- a/libavcodec/avcodec.h
+++ b/libavcodec/avcodec.h
@@ -3978,58 +3978,6 @@ int av_get_audio_frame_duration(AVCodecContext *avctx, int frame_bytes);
  */
 int av_get_audio_frame_duration2(AVCodecParameters *par, int frame_bytes);
 
-#if FF_API_OLD_BSF
-typedef struct AVBitStreamFilterContext {
-    void *priv_data;
-    const struct AVBitStreamFilter *filter;
-    AVCodecParserContext *parser;
-    struct AVBitStreamFilterContext *next;
-    /**
-     * Internal default arguments, used if NULL is passed to av_bitstream_filter_filter().
-     * Not for access by library users.
-     */
-    char *args;
-} AVBitStreamFilterContext;
-
-/**
- * @deprecated the old bitstream filtering API (using AVBitStreamFilterContext)
- * is deprecated. Use the new bitstream filtering API (using AVBSFContext).
- */
-attribute_deprecated
-void av_register_bitstream_filter(AVBitStreamFilter *bsf);
-/**
- * @deprecated the old bitstream filtering API (using AVBitStreamFilterContext)
- * is deprecated. Use av_bsf_get_by_name(), av_bsf_alloc(), and av_bsf_init()
- * from the new bitstream filtering API (using AVBSFContext).
- */
-attribute_deprecated
-AVBitStreamFilterContext *av_bitstream_filter_init(const char *name);
-/**
- * @deprecated the old bitstream filtering API (using AVBitStreamFilterContext)
- * is deprecated. Use av_bsf_send_packet() and av_bsf_receive_packet() from the
- * new bitstream filtering API (using AVBSFContext).
- */
-attribute_deprecated
-int av_bitstream_filter_filter(AVBitStreamFilterContext *bsfc,
-                               AVCodecContext *avctx, const char *args,
-                               uint8_t **poutbuf, int *poutbuf_size,
-                               const uint8_t *buf, int buf_size, int keyframe);
-/**
- * @deprecated the old bitstream filtering API (using AVBitStreamFilterContext)
- * is deprecated. Use av_bsf_free() from the new bitstream filtering API (using
- * AVBSFContext).
- */
-attribute_deprecated
-void av_bitstream_filter_close(AVBitStreamFilterContext *bsf);
-/**
- * @deprecated the old bitstream filtering API (using AVBitStreamFilterContext)
- * is deprecated. Use av_bsf_iterate() from the new bitstream filtering API (using
- * AVBSFContext).
- */
-attribute_deprecated
-const AVBitStreamFilter *av_bitstream_filter_next(const AVBitStreamFilter *f);
-#endif
-
 /* memory */
 
 /**
diff --git a/libavcodec/bitstream_filter.c b/libavcodec/bitstream_filter.c
deleted file mode 100644
index ca11ed371e..0000000000
--- a/libavcodec/bitstream_filter.c
+++ /dev/null
@@ -1,185 +0,0 @@
-/*
- * copyright (c) 2006 Michael Niedermayer <michaelni@gmx.at>
- *
- * This file is part of FFmpeg.
- *
- * FFmpeg is free software; you can redistribute it and/or
- * modify it under the terms of the GNU Lesser General Public
- * License as published by the Free Software Foundation; either
- * version 2.1 of the License, or (at your option) any later version.
- *
- * FFmpeg is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public
- * License along with FFmpeg; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
- */
-
-#include <string.h>
-
-#include "avcodec.h"
-#include "libavutil/internal.h"
-#include "libavutil/mem.h"
-#include "libavutil/opt.h"
-
-#if FF_API_OLD_BSF
-FF_DISABLE_DEPRECATION_WARNINGS
-
-const AVBitStreamFilter *av_bitstream_filter_next(const AVBitStreamFilter *f)
-{
-    const AVBitStreamFilter *filter = NULL;
-    void *opaque = NULL;
-
-    while (filter != f)
-        filter = av_bsf_iterate(&opaque);
-
-    return av_bsf_iterate(&opaque);
-}
-
-void av_register_bitstream_filter(AVBitStreamFilter *bsf)
-{
-}
-
-typedef struct BSFCompatContext {
-    AVBSFContext *ctx;
-    int extradata_updated;
-} BSFCompatContext;
-
-AVBitStreamFilterContext *av_bitstream_filter_init(const char *name)
-{
-    AVBitStreamFilterContext *ctx = NULL;
-    BSFCompatContext         *priv = NULL;
-    const AVBitStreamFilter *bsf;
-
-    bsf = av_bsf_get_by_name(name);
-    if (!bsf)
-        return NULL;
-
-    ctx = av_mallocz(sizeof(*ctx));
-    if (!ctx)
-        return NULL;
-
-    priv = av_mallocz(sizeof(*priv));
-    if (!priv)
-        goto fail;
-
-
-    ctx->filter    = bsf;
-    ctx->priv_data = priv;
-
-    return ctx;
-
-fail:
-    if (priv)
-        av_bsf_free(&priv->ctx);
-    av_freep(&priv);
-    av_freep(&ctx);
-    return NULL;
-}
-
-void av_bitstream_filter_close(AVBitStreamFilterContext *bsfc)
-{
-    BSFCompatContext *priv;
-
-    if (!bsfc)
-        return;
-
-    priv = bsfc->priv_data;
-
-    av_bsf_free(&priv->ctx);
-    av_freep(&bsfc->priv_data);
-    av_free(bsfc);
-}
-
-int av_bitstream_filter_filter(AVBitStreamFilterContext *bsfc,
-                               AVCodecContext *avctx, const char *args,
-                               uint8_t **poutbuf, int *poutbuf_size,
-                               const uint8_t *buf, int buf_size, int keyframe)
-{
-    BSFCompatContext *priv = bsfc->priv_data;
-    AVPacket pkt = { 0 };
-    int ret;
-
-    if (!priv->ctx) {
-        ret = av_bsf_alloc(bsfc->filter, &priv->ctx);
-        if (ret < 0)
-            return ret;
-
-        ret = avcodec_parameters_from_context(priv->ctx->par_in, avctx);
-        if (ret < 0)
-            return ret;
-
-        priv->ctx->time_base_in = avctx->time_base;
-
-        if (bsfc->args && bsfc->filter->priv_class) {
-            const AVOption *opt = av_opt_next(priv->ctx->priv_data, NULL);
-            const char * shorthand[2] = {NULL};
-
-            if (opt)
-                shorthand[0] = opt->name;
-
-            ret = av_opt_set_from_string(priv->ctx->priv_data, bsfc->args, shorthand, "=", ":");
-            if (ret < 0)
-                return ret;
-        }
-
-        ret = av_bsf_init(priv->ctx);
-        if (ret < 0)
-            return ret;
-    }
-
-    pkt.data = (uint8_t *)buf;
-    pkt.size = buf_size;
-
-    ret = av_bsf_send_packet(priv->ctx, &pkt);
-    if (ret < 0)
-        return ret;
-
-    *poutbuf      = NULL;
-    *poutbuf_size = 0;
-
-    ret = av_bsf_receive_packet(priv->ctx, &pkt);
-    if (ret == AVERROR(EAGAIN) || ret == AVERROR_EOF)
-        return 0;
-    else if (ret < 0)
-        return ret;
-
-    *poutbuf = av_malloc(pkt.size + AV_INPUT_BUFFER_PADDING_SIZE);
-    if (!*poutbuf) {
-        av_packet_unref(&pkt);
-        return AVERROR(ENOMEM);
-    }
-
-    *poutbuf_size = pkt.size;
-    memcpy(*poutbuf, pkt.data, pkt.size);
-
-    av_packet_unref(&pkt);
-
-    /* drain all the remaining packets we cannot return */
-    while (ret >= 0) {
-        ret = av_bsf_receive_packet(priv->ctx, &pkt);
-        av_packet_unref(&pkt);
-    }
-
-    if (!priv->extradata_updated) {
-        /* update extradata in avctx from the output codec parameters */
-        if (priv->ctx->par_out->extradata_size && (!args || !strstr(args, "private_spspps_buf"))) {
-            av_freep(&avctx->extradata);
-            avctx->extradata_size = 0;
-            avctx->extradata = av_mallocz(priv->ctx->par_out->extradata_size + AV_INPUT_BUFFER_PADDING_SIZE);
-            if (!avctx->extradata)
-                return AVERROR(ENOMEM);
-            memcpy(avctx->extradata, priv->ctx->par_out->extradata, priv->ctx->par_out->extradata_size);
-            avctx->extradata_size = priv->ctx->par_out->extradata_size;
-        }
-
-        priv->extradata_updated = 1;
-    }
-
-    return 1;
-}
-FF_ENABLE_DEPRECATION_WARNINGS
-#endif
diff --git a/libavcodec/version.h b/libavcodec/version.h
index 20641c2d2b..1068716eb9 100644
--- a/libavcodec/version.h
+++ b/libavcodec/version.h
@@ -87,9 +87,6 @@
 #ifndef FF_API_ASS_TIMING
 #define FF_API_ASS_TIMING       (LIBAVCODEC_VERSION_MAJOR < 59)
 #endif
-#ifndef FF_API_OLD_BSF
-#define FF_API_OLD_BSF          (LIBAVCODEC_VERSION_MAJOR < 59)
-#endif
 #ifndef FF_API_COPY_CONTEXT
 #define FF_API_COPY_CONTEXT     (LIBAVCODEC_VERSION_MAJOR < 59)
 #endif
diff --git a/libavformat/avformat.h b/libavformat/avformat.h
index 6c97aff423..17b54c0997 100644
--- a/libavformat/avformat.h
+++ b/libavformat/avformat.h
@@ -2953,23 +2953,6 @@ int avformat_match_stream_specifier(AVFormatContext *s, AVStream *st,
 
 int avformat_queue_attached_pictures(AVFormatContext *s);
 
-#if FF_API_OLD_BSF
-/**
- * Apply a list of bitstream filters to a packet.
- *
- * @param codec AVCodecContext, usually from an AVStream
- * @param pkt the packet to apply filters to. If, on success, the returned
- *        packet has size == 0 and side_data_elems == 0, it indicates that
- *        the packet should be dropped
- * @param bsfc a NULL-terminated list of filters to apply
- * @return  >=0 on success;
- *          AVERROR code on failure
- */
-attribute_deprecated
-int av_apply_bitstream_filters(AVCodecContext *codec, AVPacket *pkt,
-                               AVBitStreamFilterContext *bsfc);
-#endif
-
 enum AVTimebaseSource {
     AVFMT_TBCF_AUTO = -1,
     AVFMT_TBCF_DECODER,
diff --git a/libavformat/utils.c b/libavformat/utils.c
index d4ec3d0190..02768aca1f 100644
--- a/libavformat/utils.c
+++ b/libavformat/utils.c
@@ -5669,64 +5669,6 @@ int ff_stream_add_bitstream_filter(AVStream *st, const char *name, const char *a
     return 1;
 }
 
-#if FF_API_OLD_BSF
-FF_DISABLE_DEPRECATION_WARNINGS
-int av_apply_bitstream_filters(AVCodecContext *codec, AVPacket *pkt,
-                               AVBitStreamFilterContext *bsfc)
-{
-    int ret = 0;
-    while (bsfc) {
-        AVPacket new_pkt = *pkt;
-        int a = av_bitstream_filter_filter(bsfc, codec, NULL,
-                                           &new_pkt.data, &new_pkt.size,
-                                           pkt->data, pkt->size,
-                                           pkt->flags & AV_PKT_FLAG_KEY);
-        if (a == 0 && new_pkt.size == 0 && new_pkt.side_data_elems == 0) {
-            av_packet_unref(pkt);
-            memset(pkt, 0, sizeof(*pkt));
-            return 0;
-        }
-        if(a == 0 && new_pkt.data != pkt->data) {
-            uint8_t *t = av_malloc(new_pkt.size + AV_INPUT_BUFFER_PADDING_SIZE); //the new should be a subset of the old so cannot overflow
-            if (t) {
-                memcpy(t, new_pkt.data, new_pkt.size);
-                memset(t + new_pkt.size, 0, AV_INPUT_BUFFER_PADDING_SIZE);
-                new_pkt.data = t;
-                new_pkt.buf = NULL;
-                a = 1;
-            } else {
-                a = AVERROR(ENOMEM);
-            }
-        }
-        if (a > 0) {
-            new_pkt.buf = av_buffer_create(new_pkt.data, new_pkt.size,
-                                           av_buffer_default_free, NULL, 0);
-            if (new_pkt.buf) {
-                pkt->side_data = NULL;
-                pkt->side_data_elems = 0;
-                av_packet_unref(pkt);
-            } else {
-                av_freep(&new_pkt.data);
-                a = AVERROR(ENOMEM);
-            }
-        }
-        if (a < 0) {
-            av_log(codec, AV_LOG_ERROR,
-                   "Failed to open bitstream filter %s for stream %d with codec %s",
-                   bsfc->filter->name, pkt->stream_index,
-                   codec->codec ? codec->codec->name : "copy");
-            ret = a;
-            break;
-        }
-        *pkt = new_pkt;
-
-        bsfc = bsfc->next;
-    }
-    return ret;
-}
-FF_ENABLE_DEPRECATION_WARNINGS
-#endif
-
 int ff_format_output_open(AVFormatContext *s, const char *url, AVDictionary **options)
 {
     if (!s->oformat)