diff --git a/libavcodec/Makefile b/libavcodec/Makefile
index 829ff88e1d..d3b6db0b49 100644
--- a/libavcodec/Makefile
+++ b/libavcodec/Makefile
@@ -1079,6 +1079,7 @@ OBJS-$(CONFIG_AAC_PARSER)              += aac_parser.o aac_ac3_parser.o \
                                           mpeg4audio.o
 OBJS-$(CONFIG_AC3_PARSER)              += ac3tab.o aac_ac3_parser.o
 OBJS-$(CONFIG_ADX_PARSER)              += adx_parser.o adx.o
+OBJS-$(CONFIG_AMR_PARSER)              += amr_parser.o
 OBJS-$(CONFIG_AV1_PARSER)              += av1_parser.o
 OBJS-$(CONFIG_AVS2_PARSER)             += avs2_parser.o
 OBJS-$(CONFIG_AVS3_PARSER)             += avs3_parser.o
diff --git a/libavcodec/amr_parser.c b/libavcodec/amr_parser.c
new file mode 100644
index 0000000000..dc622f65f3
--- /dev/null
+++ b/libavcodec/amr_parser.c
@@ -0,0 +1,103 @@
+/*
+ * Copyright (c) 2021 Paul B Mahol
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+/**
+ * @file
+ * ADX audio parser
+ *
+ * Splits packets into individual blocks.
+ */
+
+#include "libavutil/intreadwrite.h"
+#include "parser.h"
+
+static const uint8_t amrnb_packed_size[16] = {
+    13, 14, 16, 18, 20, 21, 27, 32, 6, 1, 1, 1, 1, 1, 1, 1
+};
+static const uint8_t amrwb_packed_size[16] = {
+    18, 24, 33, 37, 41, 47, 51, 59, 61, 6, 1, 1, 1, 1, 1, 1
+};
+
+typedef struct AMRParseContext {
+    ParseContext pc;
+    uint64_t cumulated_size;
+    uint64_t block_count;
+    int remaining;
+} AMRParseContext;
+
+static int amr_parse(AVCodecParserContext *s1,
+                     AVCodecContext *avctx,
+                     const uint8_t **poutbuf, int *poutbuf_size,
+                     const uint8_t *buf, int buf_size)
+{
+    AMRParseContext *s = s1->priv_data;
+    ParseContext *pc = &s->pc;
+    int next = END_NOT_FOUND;
+
+    *poutbuf_size = 0;
+    *poutbuf = NULL;
+
+    if (s1->flags & PARSER_FLAG_COMPLETE_FRAMES) {
+        next = buf_size;
+    } else {
+        if (s->remaining) {
+            next = s->remaining;
+        } else {
+            int mode = (buf[0] >> 3) & 0x0F;
+
+            if (avctx->codec_id == AV_CODEC_ID_AMR_NB) {
+                next = amrnb_packed_size[mode];
+            } else if (avctx->codec_id == AV_CODEC_ID_AMR_WB) {
+                next = amrwb_packed_size[mode];
+            }
+        }
+
+        s->remaining = next - FFMIN(buf_size, next);
+        if (s->remaining)
+            next = END_NOT_FOUND;
+
+        if (next != END_NOT_FOUND) {
+            if (s->cumulated_size < UINT64_MAX - next) {
+                s->cumulated_size += next;
+                /* Both AMR formats have 50 frames per second */
+                avctx->bit_rate = s->cumulated_size / ++s->block_count * 8 * 50;
+            }
+        }
+
+        if (ff_combine_frame(pc, next, &buf, &buf_size) < 0) {
+            *poutbuf      = NULL;
+            *poutbuf_size = 0;
+            return buf_size;
+        }
+    }
+
+    s1->duration = avctx->codec_id == AV_CODEC_ID_AMR_NB ? 160 : 320;
+
+    *poutbuf = buf;
+    *poutbuf_size = buf_size;
+    return next;
+}
+
+const AVCodecParser ff_amr_parser = {
+    .codec_ids      = { AV_CODEC_ID_AMR_NB, AV_CODEC_ID_AMR_WB },
+    .priv_data_size = sizeof(AMRParseContext),
+    .parser_parse   = amr_parse,
+    .parser_close   = ff_parse_close,
+};
diff --git a/libavcodec/parsers.c b/libavcodec/parsers.c
index 5ab1a226d9..6b40c18d80 100644
--- a/libavcodec/parsers.c
+++ b/libavcodec/parsers.c
@@ -24,6 +24,7 @@ extern const AVCodecParser ff_aac_parser;
 extern const AVCodecParser ff_aac_latm_parser;
 extern const AVCodecParser ff_ac3_parser;
 extern const AVCodecParser ff_adx_parser;
+extern const AVCodecParser ff_amr_parser;
 extern const AVCodecParser ff_av1_parser;
 extern const AVCodecParser ff_avs2_parser;
 extern const AVCodecParser ff_avs3_parser;
diff --git a/libavformat/amr.c b/libavformat/amr.c
index 836b276fd5..8e79caee18 100644
--- a/libavformat/amr.c
+++ b/libavformat/amr.c
@@ -29,11 +29,11 @@ Only mono files are supported.
 #include "libavutil/channel_layout.h"
 #include "avformat.h"
 #include "internal.h"
+#include "rawdec.h"
 #include "rawenc.h"
 
-typedef struct {
-    uint64_t cumulated_size;
-    uint64_t block_count;
+typedef struct AMRContext {
+    FFRawDemuxerContext rawctx;
 } AMRContext;
 
 static const char AMR_header[]   = "#!AMR\n";
@@ -108,56 +108,12 @@ static int amr_read_header(AVFormatContext *s)
     st->codecpar->channels   = 1;
     st->codecpar->channel_layout = AV_CH_LAYOUT_MONO;
     st->codecpar->codec_type = AVMEDIA_TYPE_AUDIO;
+    ffstream(st)->need_parsing = AVSTREAM_PARSE_FULL_RAW;
     avpriv_set_pts_info(st, 64, 1, st->codecpar->sample_rate);
 
     return 0;
 }
 
-static int amr_read_packet(AVFormatContext *s, AVPacket *pkt)
-{
-    AVCodecParameters *par = s->streams[0]->codecpar;
-    int read, size = 0, toc, mode;
-    int64_t pos = avio_tell(s->pb);
-    AMRContext *amr = s->priv_data;
-
-    if (avio_feof(s->pb)) {
-        return AVERROR_EOF;
-    }
-
-    // FIXME this is wrong, this should rather be in an AVParser
-    toc  = avio_r8(s->pb);
-    mode = (toc >> 3) & 0x0F;
-
-    if (par->codec_id == AV_CODEC_ID_AMR_NB) {
-        size = amrnb_packed_size[mode];
-    } else if (par->codec_id == AV_CODEC_ID_AMR_WB) {
-        size = amrwb_packed_size[mode];
-    }
-
-    if (!size || av_new_packet(pkt, size))
-        return AVERROR(EIO);
-
-    if (amr->cumulated_size < UINT64_MAX - size) {
-        amr->cumulated_size += size;
-        /* Both AMR formats have 50 frames per second */
-        s->streams[0]->codecpar->bit_rate = amr->cumulated_size / ++amr->block_count * 8 * 50;
-    }
-
-    pkt->stream_index = 0;
-    pkt->pos          = pos;
-    pkt->data[0]      = toc;
-    pkt->duration     = par->codec_id == AV_CODEC_ID_AMR_NB ? 160 : 320;
-    read              = avio_read(s->pb, pkt->data + 1, size - 1);
-
-    if (read != size - 1) {
-        if (read < 0)
-            return read;
-        return AVERROR(EIO);
-    }
-
-    return 0;
-}
-
 #if CONFIG_AMR_DEMUXER
 const AVInputFormat ff_amr_demuxer = {
     .name           = "amr",
@@ -165,8 +121,9 @@ const AVInputFormat ff_amr_demuxer = {
     .priv_data_size = sizeof(AMRContext),
     .read_probe     = amr_probe,
     .read_header    = amr_read_header,
-    .read_packet    = amr_read_packet,
+    .read_packet    = ff_raw_read_partial_packet,
     .flags          = AVFMT_GENERIC_INDEX,
+    .priv_class     = &ff_raw_demuxer_class,
 };
 #endif
 
@@ -210,6 +167,7 @@ static int amrnb_read_header(AVFormatContext *s)
     st->codecpar->channels       = 1;
     st->codecpar->channel_layout = AV_CH_LAYOUT_MONO;
     st->codecpar->codec_type     = AVMEDIA_TYPE_AUDIO;
+    ffstream(st)->need_parsing   = AVSTREAM_PARSE_FULL_RAW;
     avpriv_set_pts_info(st, 64, 1, 8000);
 
     return 0;
@@ -221,8 +179,9 @@ const AVInputFormat ff_amrnb_demuxer = {
     .priv_data_size = sizeof(AMRContext),
     .read_probe     = amrnb_probe,
     .read_header    = amrnb_read_header,
-    .read_packet    = amr_read_packet,
+    .read_packet    = ff_raw_read_partial_packet,
     .flags          = AVFMT_GENERIC_INDEX,
+    .priv_class     = &ff_raw_demuxer_class,
 };
 #endif
 
@@ -266,6 +225,7 @@ static int amrwb_read_header(AVFormatContext *s)
     st->codecpar->channels       = 1;
     st->codecpar->channel_layout = AV_CH_LAYOUT_MONO;
     st->codecpar->codec_type     = AVMEDIA_TYPE_AUDIO;
+    ffstream(st)->need_parsing   = AVSTREAM_PARSE_FULL_RAW;
     avpriv_set_pts_info(st, 64, 1, 16000);
 
     return 0;
@@ -277,8 +237,9 @@ const AVInputFormat ff_amrwb_demuxer = {
     .priv_data_size = sizeof(AMRContext),
     .read_probe     = amrwb_probe,
     .read_header    = amrwb_read_header,
-    .read_packet    = amr_read_packet,
+    .read_packet    = ff_raw_read_partial_packet,
     .flags          = AVFMT_GENERIC_INDEX,
+    .priv_class     = &ff_raw_demuxer_class,
 };
 #endif
 