diff --git a/libavcodec/Makefile b/libavcodec/Makefile
index 1d75cfe..69734ca 100644
--- a/libavcodec/Makefile
+++ b/libavcodec/Makefile
@@ -244,6 +244,7 @@ OBJS-$(CONFIG_BINKAUDIO_DCT_DECODER)   += binkaudio.o
 OBJS-$(CONFIG_BINKAUDIO_RDFT_DECODER)  += binkaudio.o
 OBJS-$(CONFIG_BINTEXT_DECODER)         += bintext.o cga_data.o
 OBJS-$(CONFIG_S210_DECODER)            += s210dec.o
+OBJS-$(CONFIG_S210_ENCODER)            += s210enc.o
 OBJS-$(CONFIG_BMP_DECODER)             += bmp.o msrledec.o
 OBJS-$(CONFIG_BMP_ENCODER)             += bmpenc.o
 OBJS-$(CONFIG_BMV_AUDIO_DECODER)       += bmvaudio.o
diff --git a/libavcodec/allcodecs.c b/libavcodec/allcodecs.c
index c461798..77f5ed4 100644
--- a/libavcodec/allcodecs.c
+++ b/libavcodec/allcodecs.c
@@ -65,6 +65,7 @@ extern const AVCodec ff_bethsoftvid_decoder;
 extern const AVCodec ff_bfi_decoder;
 extern const AVCodec ff_bink_decoder;
 extern const AVCodec ff_s210_decoder;
+extern const AVCodec ff_s210_encoder;
 extern const AVCodec ff_bmp_encoder;
 extern const AVCodec ff_bmp_decoder;
 extern const AVCodec ff_bmv_video_decoder;
diff --git a/libavcodec/s210enc.c b/libavcodec/s210enc.c
new file mode 100644
index 0000000..c24f466
--- /dev/null
+++ b/libavcodec/s210enc.c
@@ -0,0 +1,90 @@
+/*
+ * S210 decoder
+ *
+ * Copyright (c) 2021 Limin Wang
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "avcodec.h"
+#include "encode.h"
+#include "internal.h"
+#include "put_bits.h"
+
+static av_cold int encode_init(AVCodecContext *avctx)
+{
+    if (avctx->width & 1) {
+        av_log(avctx, AV_LOG_ERROR, "s210 needs even width\n");
+        return AVERROR(EINVAL);
+    }
+
+    avctx->bits_per_coded_sample = 20;
+    avctx->bit_rate = ff_guess_coded_bitrate(avctx);
+
+    return 0;
+}
+
+static int encode_frame(AVCodecContext *avctx, AVPacket *pkt,
+                        const AVFrame *frame, int *got_packet)
+{
+    const int buf_size = avctx->height * avctx->width * 20 / 8;
+    int ret;
+    uint8_t *dst;
+    const uint16_t *y;
+    const uint16_t *u;
+    const uint16_t *v;
+    PutBitContext pb;
+
+    ret = ff_get_encode_buffer(avctx, pkt,  buf_size, 0);
+    if (ret < 0) {
+        av_log(avctx, AV_LOG_ERROR, "Error getting output packet.\n");
+        return ret;
+    }
+    dst = pkt->data;
+
+    init_put_bits(&pb, dst, buf_size);
+
+    for (int i = 0; i < avctx->height; i++) {
+        y = (uint16_t*)(frame->data[0] + i * frame->linesize[0]);
+        u = (uint16_t*)(frame->data[1] + i * frame->linesize[1]);
+        v = (uint16_t*)(frame->data[2] + i * frame->linesize[2]);
+
+        for (int j = 0; j < avctx->width; j += 2) {
+            /* u, y0, v, y1 */
+            put_bits(&pb, 10, av_clip_uintp2(*u++, 10));
+            put_bits(&pb, 10, av_clip_uintp2(*y++, 10));
+            put_bits(&pb, 10, av_clip_uintp2(*v++, 10));
+            put_bits(&pb, 10, av_clip_uintp2(*y++, 10));
+        }
+    }
+    flush_put_bits(&pb);
+
+    *got_packet = 1;
+    return 0;
+}
+
+const AVCodec ff_s210_encoder = {
+    .name           = "s210",
+    .long_name      = NULL_IF_CONFIG_SMALL("10-bit 4:2:2 packed"),
+    .type           = AVMEDIA_TYPE_VIDEO,
+    .id             = AV_CODEC_ID_S210,
+    .capabilities   = AV_CODEC_CAP_DR1,
+    .init           = encode_init,
+    .encode2        = encode_frame,
+    .pix_fmts       = (const enum AVPixelFormat[]){ AV_PIX_FMT_YUV422P10, AV_PIX_FMT_NONE },
+    .caps_internal  = FF_CODEC_CAP_INIT_THREADSAFE,
+};